Package net.sf.saxon.expr.flwor

## Class CountClause

- java.lang.Object
- - net.sf.saxon.expr.flwor.Clause
  - - net.sf.saxon.expr.flwor.CountClause

-     public class CountClause
      extends Clause

  A "count" clause in a FLWOR expression

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.saxon.expr.flwor.Clause

      `Clause.ClauseName`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CountClause()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Collect information about the navigation paths followed by this clause, for document projection purposes
    `CountClause` | `copy​(FLWORExpression flwor, RebindingMap rebindings)` | Create a copy of this clause
    `void` | `explain​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `Clause.ClauseName` | `getClauseKey()` | Get a keyword identifying what kind of clause this is
    `TuplePull` | `getPullStream​(TuplePull base, XPathContext context)` | Get a tuple stream that implements the functionality of this clause, taking its input from another tuple stream which this clause modifies
    `TuplePush` | `getPushStream​(TuplePush destination, Outputter output, XPathContext context)` | Get a push-mode tuple stream that implements the functionality of this clause, supplying its output to another tuple stream
    `LocalVariableBinding` | `getRangeVariable()` |
    `LocalVariableBinding[]` | `getRangeVariables()` | Get the number of variables bound by this clause
    `void` | `processOperands​(OperandProcessor processor)` | Process the subexpressions of this clause
    `void` | `setRangeVariable​(LocalVariableBinding binding)` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.expr.flwor.Clause

      `containsNonInlineableVariableReference, gatherVariableReferences, getConfiguration, getLocation, getPackageData, getTraceInfo, isRepeated, optimize, refineVariableType, setLocation, setPackageData, setRepeated, toShortString, typeCheck`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CountClause

          public CountClause()

  - ### Method Detail

    - #### getClauseKey

          public Clause.ClauseName getClauseKey()

      Description copied from class: `Clause`
      Get a keyword identifying what kind of clause this is
      Specified by:
        `getClauseKey` in class `Clause`
      Returns:
        the kind of clause

    - #### copy

          public CountClause copy​(FLWORExpression flwor,
                                  RebindingMap rebindings)

      Description copied from class: `Clause`
      Create a copy of this clause
      Specified by:
        `copy` in class `Clause`
      Parameters:
        `flwor` - the new FLWORExpression to contain the copied clause
      Returns:
        the copied clause

    - #### setRangeVariable

          public void setRangeVariable​(LocalVariableBinding binding)

    - #### getRangeVariable

          public LocalVariableBinding getRangeVariable()

    - #### getRangeVariables

          public LocalVariableBinding[] getRangeVariables()

      Get the number of variables bound by this clause
      Overrides:
        `getRangeVariables` in class `Clause`
      Returns:
        the number of variable bindings

    - #### getPullStream

          public TuplePull getPullStream​(TuplePull base,
                                         XPathContext context)

      Get a tuple stream that implements the functionality of this clause, taking its input from another tuple stream which this clause modifies
      Specified by:
        `getPullStream` in class `Clause`
      Parameters:
        `base` - the input tuple stream
        `context` -
      Returns:
        the output tuple stream

    - #### getPushStream

          public TuplePush getPushStream​(TuplePush destination,
                                         Outputter output,
                                         XPathContext context)

      Get a push-mode tuple stream that implements the functionality of this clause, supplying its output to another tuple stream
      Specified by:
        `getPushStream` in class `Clause`
      Parameters:
        `destination` - the output tuple stream
        `output` - the destination for the result
        `context` -
      Returns:
        the push tuple stream that implements the functionality of this clause of the FLWOR expression

    - #### processOperands

          public void processOperands​(OperandProcessor processor)
                               throws XPathException

      Process the subexpressions of this clause
      Specified by:
        `processOperands` in class `Clause`
      Parameters:
        `processor` - the expression processor used to process the subexpressions
      Throws:
        `XPathException` - if any error is detected

    - #### addToPathMap

          public void addToPathMap​(PathMap pathMap,
                                   PathMap.PathMapNodeSet pathMapNodeSet)

      Description copied from class: `Clause`
      Collect information about the navigation paths followed by this clause, for document projection purposes
      Specified by:
        `addToPathMap` in class `Clause`
      Parameters:
        `pathMap` - the path map in which the data is to be collected
        `pathMapNodeSet` - the path map node set representing the paths to the context item

    - #### explain

          public void explain​(ExpressionPresenter out)
                       throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Clause`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`